=== include/CMakeLists.txt ===
add_subdirectory(proj)
