## proj 9.5.0

=== debian/changelog ===
proj (9.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Strip pre-releases from symbols version.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 15 Sep 2024 14:20:21 +0200

proj (9.5.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Bump Standards-Version to 4.7.0, no changes.
  * Update filenames for dh_installdocs override.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 09 Sep 2024 18:32:11 +0200
