=== debian/changelog ===
proj (9.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Strip pre-releases from symbols version.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 01 Dec 2024 12:53:25 +0100

proj (9.5.1~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop generate_proj_db.patch, applied upstream.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 26 Nov 2024 20:49:02 +0100

proj (9.5.1~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Add patch to fix FTBFS due to PROJ_DB_SQL_EXPECTED_MD5.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 26 Nov 2024 14:19:59 +0100
